# How to contribute

Wechaty is a community driven open source project and we welcome any contributor. 

We have also prepared a nomination award, which can be apply after joining the organization.

## Before

### Sign the CLA

Click the Sign in with Github to agree button to sign the CLA. See an example [here](https://cla-assistant.io/wechaty/go-wechaty).

[Why CLA?](https://qastack.cn/software/168020/how-signing-out-a-cla-prevents-legal-issues-in-open-source-projects)

### Environment configuration

You also need to begin to prepare the Go development environment.

1. download archive 
2. extract archive
3. configure the path to an environment variable

Yes, it is so simple, you can check it [here](https://golang.org/doc/install)

## Action

Action is the best inspiration, contribution is the best result.

> Yes, this sentence was just made up by me. I hope express to you that the community is inclusive and open, and it is a relaxed environment.

### Choose a Topic

If you find a bug in the code, or something that can be improved, or invalid and redundant code; you can fork the project into your own repository, modify the code, and then submit the PR.

However, if you modify multiple codes at the same time, please submit them in the form of a theme, so that we can discuss separately and merge into the trunk in stages.

### How to Write Go Code

If you are new to Go, I hope [<How to Write Go Code>](https://golang.org/doc/code.html) can help you.

If you already have relevant experience, hope the following list can unify our coding style：
1. Effective Go: [https://golang.google.cn/doc/effective\_go.html](https://golang.google.cn/doc/effective\_go.html)
2. Uber Go Style Guide: [https://github.com/uber-go/guide/blob/master/style.md](https://github.com/uber-go/guide/blob/master/style.md)([译文](https://github.com/gocn/translator/blob/master/2019/w38_uber_go_style_guide.md))
3. Go Code Review Comments: [https://github.com/golang/go/wiki/CodeReviewComments](https://github.com/golang/go/wiki/CodeReviewComments)

At the same time, we have configured related robots on PR to check the syntax and code style of the code.

## After

### Join Github Org Team

If you have two PRs that are merged and valid, you will be invited to join Team, of course, the choice is yours.

### Nomination

After joining the github team, please submit an application in the issue below: [Wechaty Contributors Nomination](https://github.com/wechaty/PMC/issues/16)
